异常

当你的程序中出现某些 异常的 状况的时候,异常就发生了。例如,当你想要读某个文件的时候,而那个文件不存在。或者在程序运行的时候,你不小心把它删除了。上述这些情况可以使用异常来处理。

假如你的程序中有一些无效的语句,会怎么样呢?Python会引发并告诉你那里有一个错误,从而处理这样的情况。

考虑一个简单的print语句。假如我们把print误拼为Print,注意大写,这样Python会 引发 一个语法错误。

>>> Print 'Hello World'
    File "<stdin>", line 1
      Print 'Hello World'
                        ^
SyntaxError: invalid syntax

>>> print 'Hello World'
Hello World

我们可以观察到有一个SyntaxError被引发,并且检测到的错误位置也被打印了出来。这是这个错误的 错误处理器 所做的工作。

try..except

我们尝试读取用户的一段输入。按Ctrl-d,看一下会发生什么。

>>> s = raw_input('Enter something --> ')
Enter something --> Traceback (most recent call last):
  File "<stdin>", line 1, in ?
EOFError

Python引发了一个称为EOFError的错误,这个错误基本上意味着它发现一个不期望的 文件尾 (由Ctrl-d表示)

我们可以使用try..except语句来处理异常。我们把通常的语句放在try-块中,而把我们的错误处理语句放在except-块中。

   1 #!/usr/bin/python
   2 
   3 import sys
   4 
   5 try:
   6     s = raw_input('Enter something --> ')
   7 except EOFError:
   8     print '\nWhy did you do an EOF on me?'
   9     sys.exit() # exit the program
  10 except:
  11     print '\nSome error/exception occurred.'
  12     # here, we are not exiting the program
  13 
  14 print 'Done' 

输入输出

$ python try_except.py
Enter something -->
Why did you do an EOF on me?

$ python try_except.py
Enter something --> Python is exceptional!
Done

我们把所有可能引发错误的语句放在try块中,然后在except从句/块中处理所有的错误和异常。except从句可以专门处理单一的错误或异常,或者一组包括在圆括号内的错误/异常。如果没有给出错误或异常的名称,它会处理 所有的 错误和异常。对于每个try从句,至少都有一个相关联的except从句。

如果某个错误或异常没有被处理,默认的Python处理器就会被调用。它会终止程序的运行,并且打印一个消息,我们已经看到了这样的处理。

你还可以让try..except块关联上一个else从句。当没有异常发生的时候,else从句将被执行。

我们还可以得到异常对象,从而获取更多有个这个异常的信息。这会在下一个例子中说明。

引发异常

你可以使用raise语句 引发 异常。你还得指明错误/异常的名称和伴随异常 触发的 异常对象。你可以引发的错误或异常应该分别是一个Error或Exception类的直接或间接导出类。

   1 #!/usr/bin/python
   2 
   3 class ShortInputException(Exception):
   4     '''A user-defined exception class.'''
   5     def __init__(self, length, atleast):
   6         Exception.__init__(self)
   7         self.length = length
   8         self.atleast = atleast
   9 
  10 try:
  11     s = raw_input('Enter something --> ')
  12     if len(s) < 3:
  13         raise ShortInputException(len(s), 3)
  14     # Other work can continue as usual here
  15 except EOFError:
  16     print '\nWhy did you do an EOF on me?'
  17 except ShortInputException, x:
  18     print 'ShortInputException: The input was of length %d, \
  19           was expecting at least %d' % (x.length, x.atleast)
  20 else:
  21     print 'No exception was raised.'

输入输出

$ python raising.py
Enter something -->
Why did you do an EOF on me?

$ python raising.py
Enter something --> ab
ShortInputException: The input was of length 2, was expecting at least 3

$ python raising.py
Enter something --> abc
No exception was raised.

这里,我们创建了我们自己的异常类型,其实我们可以使用任何预定义的异常/错误。这个新的异常类型是ShortInputException类。它有两个域——length是给定输入的长度,atleast则是程序期望的最小长度。

在except从句中,我们提供了错误类和用来表示错误/异常对象的变量。这与函数调用中的形参和实参概念类似。在这个特别的except从句中,我们使用异常对象的length和atleast域来为用户打印一个恰当的消息。

try..finally

假如你在读一个文件的时候,希望在无论异常发生与否的情况下都关闭文件,该怎么做呢?这可以使用finally块来完成。注意,在一个try块下,你可以同时使用except从句和finally块。如果你要同时使用它们的话,需要把一个嵌入另外一个。

   1 #!/usr/bin/python
   2 
   3 import time
   4 
   5 try:
   6     f = file('poem.txt')
   7     while True: # our usual file-reading idiom
   8         line = f.readline()
   9         if len(line) == 0:
  10             break
  11         time.sleep(2)
  12         print line,
  13 finally:
  14     f.close()
  15     print 'Cleaning up...closed the file'

输出

Programming is fun
When the work is done
Cleaning up...closed the file
Traceback (most recent call last):
  File "finally.py", line 12, in ?
    time.sleep(2)
KeyboardInterrupt

我们进行通常的读文件工作,但是我有意在每打印一行之前用time.sleep方法暂停2秒钟。这样做的原因是让程序运行得慢一些(Python由于其本质通常运行得很快)。在程序运行的时候,按Ctrl-c中断/取消程序。

我们可以观察到KeyboardInterrupt异常被触发,程序退出。但是在程序退出之前,finally从句仍然被执行,把文件关闭

end

Python语言的异常处理 (last edited 2008-02-23 15:34:17 by localhost)

ch3n2k.com | Copyright (c) 2008 czk. 浙ICP备06000584号